{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,
  mckCtrls {$ENDIF (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    TV: TKOLTreeView;
    PM: TKOLPopupMenu;
    Panel1: TKOLPanel;
    Button1: TKOLButton;
    Label1: TKOLLabel;
    procedure PMPopup(Sender: PObj);
    procedure PMpmAddRootMenu(Sender: PMenu; Item: Integer);
    procedure PMpmAddSubitemMenu(Sender: PMenu; Item: Integer);
    procedure PMpmDeleteMenu(Sender: PMenu; Item: Integer);
    procedure TVTVBeginDrag(Sender: PControl; Item: Cardinal);
    procedure TVMouseUp(Sender: PControl; var Mouse: TMouseEventData);
    procedure TVMouseMove(Sender: PControl; var Mouse: TMouseEventData);
    procedure Button1Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
    TV_DragItem: Integer;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.PMPopup(Sender: PObj);
begin
  PM.ItemEnabled[ pmAddSubitem ] := TV.TVSelected <> 0;
  PM.ItemEnabled[ pmDelete ] := TV.TVSelected <> 0;
end;

procedure TForm1.PMpmAddRootMenu(Sender: PMenu; Item: Integer);
var i: Integer;
begin
  i := TV.TVInsert( 0, 0, 'New item' );
  TV.TVSelected := i;
  TV.TVEditItem( i );
end;

procedure TForm1.PMpmAddSubitemMenu(Sender: PMenu; Item: Integer);
var i: Integer;
begin
  i := TV.TVInsert( TV.TVSelected, 0, 'New subitem' );
  TV.TVSelected := i;
  TV.TVEditItem( i );
end;

procedure TForm1.PMpmDeleteMenu(Sender: PMenu; Item: Integer);
begin
  TV.TVDelete( TV.TVSelected );
end;

procedure TForm1.TVTVBeginDrag(Sender: PControl; Item: Cardinal);
begin
  TV_DragItem := Item;
  SetCapture( TV.Handle );
  TV.Cursor := LoadCursor( 0, IDC_HAND );
  SetCursor( TV.Cursor );
end;

procedure TForm1.TVMouseUp(Sender: PControl; var Mouse: TMouseEventData);
var i, j, k: Integer;
    Where: DWORD;

    procedure CopyItemAttrs( from_item, to_item: Integer );
    begin
      TV.TVItemData[ to_item ] := TV.TVItemData[ from_item ];
      TV.TVItemData[ from_item ] := nil;
      TV.TVItemImage[ to_item ] := TV.TVItemImage[ from_item ];
      TV.TVItemSelected[ to_item ] := TV.TVItemSelected[ from_item ];
      TV.TVItemStateImg[ to_item ] := TV.TVItemStateImg[ from_item ];
    end;

    procedure MoveSubItems( from_item, to_item: Integer );
    var n, m, d: Integer;
    begin
      n := TV.TVItemChild[ from_item ];
      while n <> 0 do
      begin
        m := TV.TVInsert( to_item, 0, TV.TVItemText[ n ] );
        CopyItemAttrs( n, m );
        MoveSubItems( n, m );
        d := n;
        n := TV.TVItemNext[ n ];
        TV.TVDelete( d );
      end;
    end;
begin
  if TV_DragItem <> 0 then
  begin
    TV.TVDropHilited := 0;
    TV.Cursor := LoadCursor( 0, IDC_ARROW );
    SetCursor( TV.Cursor );
    ReleaseCapture;
    j := TV_DragItem;
    TV_DragItem := 0;
    i := TV.TVItemAtPos( Mouse.X, Mouse.Y, Where );
    if (i = 0) or (i = j) then Exit;
    if GetKeyState( VK_SHIFT ) < 0 then
      k := TV.TVInsert( i, 0, TV.TVItemText[ j ] )
    else
      k := TV.TVInsert( TV.TVItemParent[ i ], i, TV.TVItemText[ j ] );
    CopyItemAttrs( j, k );
    TV.TVSelected := k;
    MoveSubItems( j, k );
    TV.TVDelete( j );
  end;
end;

procedure TForm1.TVMouseMove(Sender: PControl; var Mouse: TMouseEventData);
var i: Integer;
    where: DWORD;
begin
  if TV_DragItem <> 0 then
  begin
    i := TV.TVItemAtPos( Mouse.X, Mouse.Y, where );
    if (i = 0) or (i = TV_DragItem) then
      TV.TVDropHilited := 0
    else
      TV.TVDropHilited := i;
  end;
end;

procedure TForm1.Button1Click(Sender: PObj);
  function CountTVItems( from: Integer ): Integer;
  begin
    Result := 0;
    while from <> 0 do
    begin
      inc( Result, CountTVItems( TV.TVItemChild[ from ] ) );
      from := TV.TVItemNext[ from ];
    end;
  end;
  function FindItem( var r: Integer; from: Integer ): Integer;
  begin
    Result := 0;
    while from <> 0 do
    begin
      Result := FindItem( r, TV.TVItemChild[ from ] );
      if Result <> 0 then Exit;
      from := TV.TVItemNext[ from ];
      Dec( r );
      if r <= 0 then
      begin
        Result := from;
        Exit;
      end;
    end;
  end;
var i, r, j, p: Integer;
    n: Integer;
begin
  n := CountTVItems( TV.TVRoot );
  for i := 0 to 9 do
  begin
    r := Random( n + 1 );
    j := FindItem( r, TV.TVRoot );
    if Random( 20 ) = 0 then
    begin
      p := TV.TVItemParent[ j ];
      TV.TVInsert( p, j, 'Item' + StrRepeat( Int2Str( i ), 4 ) )
    end
    else
    begin
      p := j;
      TV.TVInsert( j, 0, 'Item' + StrRepeat( Int2Str( i ), 4 ) );
    end;
    TV.TVExpand( p, TVE_EXPAND );
    inc( n );
  end;
end;

end.


